<html>
<head>
<title>Ogre::MovableObjectFactory Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1MovableObjectFactory.html">MovableObjectFactory</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::MovableObjectFactory Class Reference<div class="ingroups"><a class="el" href="group__Scene.html">Scene</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::MovableObjectFactory" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Interface definition for a factory class which produces a certain kind of <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>, and can be registered with <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> in order to allow all clients to produce new instances of this object, integrated with the standard <a class="el" href="namespaceOgre.html">Ogre</a> processing.  
 <a href="classOgre_1_1MovableObjectFactory.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::MovableObjectFactory:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1MovableObjectFactory__inherit__graph.gif" border="0" usemap="#Ogre_1_1MovableObjectFactory_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1MovableObjectFactory_inherit__map" id="Ogre_1_1MovableObjectFactory_inherit__map">
<area shape="rect" id="node5" href="classOgre_1_1BillboardChainFactory.html" title="Factory object for creating BillboardChain instances." alt="" coords="395,5,581,35"/><area shape="rect" id="node7" href="classOgre_1_1BillboardSetFactory.html" title="Factory object for creating BillboardSet instances." alt="" coords="403,59,573,88"/><area shape="rect" id="node9" href="classOgre_1_1EntityFactory.html" title="Factory object for creating Entity instances." alt="" coords="420,112,556,141"/><area shape="rect" id="node11" href="classOgre_1_1LightFactory.html" title="Factory object for creating Light instances." alt="" coords="423,165,553,195"/><area shape="rect" id="node13" href="classOgre_1_1ManualObjectFactory.html" title="Factory object for creating ManualObject instances." alt="" coords="397,219,579,248"/><area shape="rect" id="node15" href="classOgre_1_1ParticleSystemFactory.html" title="Factory object for creating ParticleSystem instances." alt="" coords="393,272,583,301"/><area shape="rect" id="node17" href="classOgre_1_1RibbonTrailFactory.html" title="Factory object for creating RibbonTrail instances." alt="" coords="404,325,572,355"/><area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="7,165,105,195"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1MovableObjectFactory-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a20ebc986aa86806dc61a95e86312500f">MovableObjectFactory</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a102fc90d87f01bbd0680ccb58a2d5050">~MovableObjectFactory</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a0b45580fccdefe99312afa67265264fc">getType</a> (void) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of the object to be created.  <a href="#a0b45580fccdefe99312afa67265264fc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1MovableObject.html">MovableObject</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a7164ba391aead569e43e5713c7281d7b">createInstance</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *manager, const <a class="el" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19">NameValuePairList</a> *params=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a new instance of the object.  <a href="#a7164ba391aead569e43e5713c7281d7b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#aae1cdb0b70854af1c84e23d5b45dfb30">destroyInstance</a> (<a class="el" href="classOgre_1_1MovableObject.html">MovableObject</a> *obj)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy an instance of the object.  <a href="#aae1cdb0b70854af1c84e23d5b45dfb30"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a80346bc406655855ec5e0eef198900f2">requestTypeFlags</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Does this factory require the allocation of a 'type flag', used to selectively include / exclude this type from scene queries?  <a href="#a80346bc406655855ec5e0eef198900f2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#afe63ec95c506e97e9abca23b7fd1a537">_notifyTypeFlags</a> (unsigned long flag)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Notify this factory of the type mask to apply.  <a href="#afe63ec95c506e97e9abca23b7fd1a537"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a9b2028dca564c74453994926db4f50d0">getTypeFlags</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the type flag for this factory.  <a href="#a9b2028dca564c74453994926db4f50d0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1MovableObject.html">MovableObject</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#ad42862ff29a901487569f425ebcaffc0">createInstanceImpl</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, const <a class="el" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19">NameValuePairList</a> *params=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal implementation of create method - must be overridden.  <a href="#ad42862ff29a901487569f425ebcaffc0"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MovableObjectFactory.html#ad35a2db6426d02a75b85f133a26d5387">mTypeFlag</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Type flag, allocated if requested.  <a href="#ad35a2db6426d02a75b85f133a26d5387"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Interface definition for a factory class which produces a certain kind of <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>, and can be registered with <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> in order to allow all clients to produce new instances of this object, integrated with the standard <a class="el" href="namespaceOgre.html">Ogre</a> processing. </p>

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00577">577</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a20ebc986aa86806dc61a95e86312500f"></a><!-- doxytag: member="Ogre::MovableObjectFactory::MovableObjectFactory" ref="a20ebc986aa86806dc61a95e86312500f" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MovableObjectFactory.html#a20ebc986aa86806dc61a95e86312500f">Ogre::MovableObjectFactory::MovableObjectFactory</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00587">587</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a102fc90d87f01bbd0680ccb58a2d5050"></a><!-- doxytag: member="Ogre::MovableObjectFactory::~MovableObjectFactory" ref="a102fc90d87f01bbd0680ccb58a2d5050" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1MovableObjectFactory.html#a102fc90d87f01bbd0680ccb58a2d5050">Ogre::MovableObjectFactory::~MovableObjectFactory</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00588">588</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="afe63ec95c506e97e9abca23b7fd1a537"></a><!-- doxytag: member="Ogre::MovableObjectFactory::_notifyTypeFlags" ref="afe63ec95c506e97e9abca23b7fd1a537" args="(unsigned long flag)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1MovableObjectFactory.html#afe63ec95c506e97e9abca23b7fd1a537">Ogre::MovableObjectFactory::_notifyTypeFlags</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>flag</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Notify this factory of the type mask to apply. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This should normally only be called by <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> in response to a 'true' result from requestTypeMask. However, you can actually use it yourself if you're careful; for example to assign the same mask to a number of different types of object, should you always wish them to be treated the same in queries. </dd></dl>

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00627">627</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7164ba391aead569e43e5713c7281d7b"></a><!-- doxytag: member="Ogre::MovableObjectFactory::createInstance" ref="a7164ba391aead569e43e5713c7281d7b" args="(const String &amp;name, SceneManager *manager, const NameValuePairList *params=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1MovableObject.html">MovableObject</a>* <a class="el" href="classOgre_1_1MovableObjectFactory.html#a7164ba391aead569e43e5713c7281d7b">Ogre::MovableObjectFactory::createInstance</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>manager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19">NameValuePairList</a> *&#160;</td>
          <td class="paramname"><em>params</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new instance of the object. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the new object </td></tr>
    <tr><td class="paramname">manager</td><td>The <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> instance that will be holding the instance once created. </td></tr>
    <tr><td class="paramname">params</td><td>Name/value pair list of additional parameters required to construct the object (defined per subtype). Optional. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad42862ff29a901487569f425ebcaffc0"></a><!-- doxytag: member="Ogre::MovableObjectFactory::createInstanceImpl" ref="ad42862ff29a901487569f425ebcaffc0" args="(const String &amp;name, const NameValuePairList *params=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1MovableObject.html">MovableObject</a>* <a class="el" href="classOgre_1_1MovableObjectFactory.html#ad42862ff29a901487569f425ebcaffc0">Ogre::MovableObjectFactory::createInstanceImpl</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19">NameValuePairList</a> *&#160;</td>
          <td class="paramname"><em>params</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal implementation of create method - must be overridden. </p>

<p>Implemented in <a class="el" href="classOgre_1_1BillboardSetFactory.html#acf1ce176730c2b3e60ce6393284b0623">Ogre::BillboardSetFactory</a>, <a class="el" href="classOgre_1_1EntityFactory.html#ade100fd3b410a854d0b0327c78242f5b">Ogre::EntityFactory</a>, <a class="el" href="classOgre_1_1LightFactory.html#a0169e1290d83029c6f10466cfa278459">Ogre::LightFactory</a>, <a class="el" href="classOgre_1_1ManualObjectFactory.html#a03b92eac898b8380d5ea411c1d6a7f60">Ogre::ManualObjectFactory</a>, <a class="el" href="classOgre_1_1ParticleSystemFactory.html#abc138ad5b9aee3a52aeb83648f62202a">Ogre::ParticleSystemFactory</a>, <a class="el" href="classOgre_1_1BillboardChainFactory.html#a7d240aa0f201d72c5998cafb0092b4ef">Ogre::BillboardChainFactory</a>, and <a class="el" href="classOgre_1_1RibbonTrailFactory.html#af1377c763af01735d8df988870353969">Ogre::RibbonTrailFactory</a>.</p>

</div>
</div>
<a class="anchor" id="aae1cdb0b70854af1c84e23d5b45dfb30"></a><!-- doxytag: member="Ogre::MovableObjectFactory::destroyInstance" ref="aae1cdb0b70854af1c84e23d5b45dfb30" args="(MovableObject *obj)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1MovableObjectFactory.html#aae1cdb0b70854af1c84e23d5b45dfb30">Ogre::MovableObjectFactory::destroyInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1MovableObject.html">MovableObject</a> *&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy an instance of the object. </p>

<p>Implemented in <a class="el" href="classOgre_1_1BillboardSetFactory.html#a1d9a309182513810d2bd2ae98cc6e5be">Ogre::BillboardSetFactory</a>, <a class="el" href="classOgre_1_1EntityFactory.html#ac08df5e5199b95ffbe48d4b425919500">Ogre::EntityFactory</a>, <a class="el" href="classOgre_1_1LightFactory.html#ab128c82ed2e160d4c870baca1c041add">Ogre::LightFactory</a>, <a class="el" href="classOgre_1_1ManualObjectFactory.html#abcaadec45f403cb7d358fdb9e519de25">Ogre::ManualObjectFactory</a>, <a class="el" href="classOgre_1_1ParticleSystemFactory.html#a8ac53881aac2f64f6180cf0608919457">Ogre::ParticleSystemFactory</a>, <a class="el" href="classOgre_1_1BillboardChainFactory.html#a9057100cd94978807e668a68e1839c97">Ogre::BillboardChainFactory</a>, and <a class="el" href="classOgre_1_1RibbonTrailFactory.html#a99f934caf81126b1e149544416d5a9c4">Ogre::RibbonTrailFactory</a>.</p>

</div>
</div>
<a class="anchor" id="a0b45580fccdefe99312afa67265264fc"></a><!-- doxytag: member="Ogre::MovableObjectFactory::getType" ref="a0b45580fccdefe99312afa67265264fc" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1MovableObjectFactory.html#a0b45580fccdefe99312afa67265264fc">Ogre::MovableObjectFactory::getType</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the type of the object to be created. </p>

<p>Implemented in <a class="el" href="classOgre_1_1BillboardSetFactory.html#a87bdf3302160d4b81da5358445b93e19">Ogre::BillboardSetFactory</a>, <a class="el" href="classOgre_1_1EntityFactory.html#aa34e24618322ca2a032f402f14e32ff8">Ogre::EntityFactory</a>, <a class="el" href="classOgre_1_1LightFactory.html#a2e1493d053ac8e8bde64d59358e5cded">Ogre::LightFactory</a>, <a class="el" href="classOgre_1_1ManualObjectFactory.html#a0a97ac9f90a08a79b411bb6577ce3ac4">Ogre::ManualObjectFactory</a>, <a class="el" href="classOgre_1_1ParticleSystemFactory.html#ac2c3d845bf02059a1fbf31c3aab7fda7">Ogre::ParticleSystemFactory</a>, <a class="el" href="classOgre_1_1BillboardChainFactory.html#a024b3bb985bb96e078e8ecaa50f97471">Ogre::BillboardChainFactory</a>, and <a class="el" href="classOgre_1_1RibbonTrailFactory.html#a4ab3973b4031bb2fea6d833d7d924281">Ogre::RibbonTrailFactory</a>.</p>

</div>
</div>
<a class="anchor" id="a9b2028dca564c74453994926db4f50d0"></a><!-- doxytag: member="Ogre::MovableObjectFactory::getTypeFlags" ref="a9b2028dca564c74453994926db4f50d0" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="el" href="classOgre_1_1MovableObjectFactory.html#a9b2028dca564c74453994926db4f50d0">Ogre::MovableObjectFactory::getTypeFlags</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the type flag for this factory. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A type flag is like a query flag, except that it applies to all instances of a certain type of object. </dd></dl>

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00634">634</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::MovableObjectFactory::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a80346bc406655855ec5e0eef198900f2"></a><!-- doxytag: member="Ogre::MovableObjectFactory::requestTypeFlags" ref="a80346bc406655855ec5e0eef198900f2" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1MovableObjectFactory.html#a80346bc406655855ec5e0eef198900f2">Ogre::MovableObjectFactory::requestTypeFlags</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Does this factory require the allocation of a 'type flag', used to selectively include / exclude this type from scene queries? </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The default implementation here is to return 'false', ie not to request a unique type mask from <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>. For objects that never need to be excluded in <a class="el" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a> results, that's fine, since the default implementation of <a class="el" href="classOgre_1_1MovableObject.html#a32c637889b8a4138d2008aece76f42b6" title="Get the &#39;type flags&#39; for this MovableObject.">MovableObject::getTypeFlags</a> is to return all ones, hence matching any query type mask. However, if you want the objects created by this factory to be filterable by queries using a broad type, you have to give them a (preferably unique) type mask - and given that you don't know what other <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a> types are registered, <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> will allocate you one. </dd></dl>

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00618">618</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ad35a2db6426d02a75b85f133a26d5387"></a><!-- doxytag: member="Ogre::MovableObjectFactory::mTypeFlag" ref="ad35a2db6426d02a75b85f133a26d5387" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classOgre_1_1MovableObjectFactory.html#ad35a2db6426d02a75b85f133a26d5387">Ogre::MovableObjectFactory::mTypeFlag</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type flag, allocated if requested. </p>

<p>Definition at line <a class="el" href="OgreMovableObject_8h_source.html#l00581">581</a> of file <a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreMovableObject_8h_source.html">OgreMovableObject.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:59
</p>
</body>
</html>
